/////////////////////////////////////////////////////////////////////
// \author Jeongnim Kim
//
// An example to call Blas::daxpy
// link: -lblas
//////////////////////////////////////////////////////////////////////
#include <iostream>
#include <vector>
#include <iomanip>
using namespace std;

#ifdef __GNUC__
#define RESTRICT
#else
#define RESTRICT restrict
#endif

#ifndef SP2
#define daxpy daxpy_
#endif

extern "C" {
  void daxpy(int *n, double *da,  double *dx,
             int *incx, double *dy, int *incy);
}
 
int main(int argc, char **argv) {

  vector<double> a,b;
  int n = 10;
  int incx = 1;
  int incy = 1;

  int i=0;
  while(i<argc) {
    if(!strcmp(argv[i],"-n")) {
      n = atoi(argv[++i]);
      break;
    }
    i++;
  }

  a.resize(n);
  b.resize(n);

  double dn = 1.0/static_cast<double>(n);

  for(int i=0; i<n; i++) {
    a[i] = static_cast<double>(i+1)*dn;
    b[i] = (dn-static_cast<double>(i))*dn*0.5;
  }

  double x = 1.13;

  daxpy(&n,&x,a.begin(),&incx,b.begin(),&incy);

  for(int i=0; i<n; i++) cout << b[i] << endl;
}

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: daxpy.cpp 151 2004-11-02 23:51:14Z jnkim $
 ************************************************************************/
