#
# this module look for Metis (http://www-users.cs.umn.edu/~karypis/metis/index.html) support
# it will define the following values
#
# METIS_INCLUDE_DIR  = where metis.h can be found
# METIS_LIBRARY      = the library to link against (metis)
# FOUND_METIS        = set to true after finding the library
#
IF(EXISTS ${PROJECT_CMAKE}/MetisConfig.cmake)
  INCLUDE(${PROJECT_CMAKE}/MetisConfig.cmake)
ENDIF(EXISTS ${PROJECT_CMAKE}/MetisConfig.cmake)

IF(Metis_INCLUDE_DIRS)

  FIND_PATH(METIS_INCLUDE_DIR metis.h ${Metis_INCLUDE_DIRS})
  FIND_LIBRARY(METIS_LIBRARY metis ${Metis_LIBRARY_DIRS})

ELSE(Metis_INCLUDE_DIRS)

  SET(TRIAL_LIBRARY_PATHS
    $ENV{METIS_HOME}/lib
    /usr/lib 
    /usr/local/lib
    /opt/lib
    /sw/lib
    )

  SET(TRIAL_INCLUDE_PATHS
    $ENV{METIS_HOME}/include
    $ENV{METIS_HOME}/include/metis
    /usr/include
    /opt/include
    /usr/local/include
    /sw/include
    )

  FIND_LIBRARY(METIS_LIBRARY metis ${TRIAL_LIBRARY_PATHS})
  FIND_PATH(METIS_INCLUDE_DIR metis.h ${TRIAL_INCLUDE_PATHS} )

ENDIF(Metis_INCLUDE_DIRS)

IF(METIS_INCLUDE_DIR AND METIS_LIBRARY)
  SET(FOUND_METIS 1 CACHE BOOL "Found metis library")
ELSE(METIS_INCLUDE_DIR AND METIS_LIBRARY)
  SET(FOUND_METIS 0 CACHE BOOL "Not found metis library")
ENDIF(METIS_INCLUDE_DIR AND METIS_LIBRARY)

MARK_AS_ADVANCED(
  METIS_INCLUDE_DIR 
  METIS_LIBRARY 
  FOUND_METIS
  )
