#
#KCC or guidec++ with IBM Visual Age C/C++ backends
#                with gcc backends at OSC
#JK cannot access other platforms with KCC or guidec++
#

IF(${CMAKE_SYSTEM_NAME} MATCHES "AIX")
  MESSAGE(STATUS "AIX system with KCC or KAP")
  SET(F77 xlf)
  #####################################################
  #guidec++ only works with -q64
  #####################################################
  IF(OHMMS_OMP)
    SET(ENABLE_OPENMP 1)
    MESSAGE(STATUS "OpenMp is enabled. Make sure CXX=guidec++.")
    SET(BITS 64)
    SET(F77 guidef77)
  ENDIF(OHMMS_OMP)
  
  SET(KCC_BASE_FLAGS "+K3 -O --inline_keyword_space_time=10000 --backend -qassert=typ --backend -qspill=2000 -qmaxmem=-1 --strict --restrict --no_exceptions --one_per --no_implicit_include")
  
  IF(BITS MATCHES 64)
    ADD_DEFINITIONS(-D_LONG_LONG)
    SET(F77OPTFLAGS  -O3 -qstrict -qarch=pwr4 -qtune=pwr4 -q64)
    SET(CMAKE_CXX_FLAGS "-q64 -qlonglong ${KCC_BASE_FLAGS} --diag_suppress 450")
    SET(AR_OPTIONS "-X64")
  ELSE(BITS MATCHES 64)
    SET(F77OPTFLAGS  -O3 -qstrict -qarch=pwr4 -qtune=pwr4)
    SET(CMAKE_CXX_FLAGS ${KCC_BASE_FLAGS})
  ENDIF(BITS MATCHES 64)
  
  SET(F77FLAGS ${F77OPTFLAGS})
  SET(FORTRAN_LIBS " -lxlf90 -lxlf")
ELSE(${CMAKE_SYSTEM_NAME} MATCHES "AIX")
  MESSAGE(STATUS "Linux system with KCC or KAP: otherwise, it won't work!!!!")
  #####################################################
  #guidec++ only works with -q64
  #####################################################
  IF(OHMMS_OMP)
    MESSAGE(STATUS "OpenMp is enabled. Make sure CXX=guidec++.")
    SET(ENABLE_OPENMP 1)
  ENDIF(OHMMS_OMP)

  SET(CMAKE_CXX_FLAGS "+K3 -O --inline_keyword_space_time=10000 --strict --restrict --no_exceptions --one_per --diag_suppress 450 -WGopt=3 -WGstats")

  SET(F77 g77)
  SET(F77OPTFLAGS  -O3)
  SET(FORTRAN_LIBS " -lg2c")

  SET(F77FLAGS ${F77OPTFLAGS})
  SET(INTEL_COMPILER 1)
  ADD_DEFINITIONS(-DADD_)
ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "AIX")


######################################################
#KCC needs to be used to build static libraries
######################################################
SET(CMAKE_CXX_LINK_FLAGS ${CMAKE_CXX_FLAGS})
SET(CMAKE_CXX_CREATE_STATIC_LIBRARY
   "<CMAKE_CXX_COMPILER> <CMAKE_CXX_LINK_FLAGS> -o <TARGET> <OBJECTS>")
