/////////////////////////////////////////////////////////////////////////////
// Name:        PlotBandStructure.h
// Author:      XX
// Created:     XX/XX/XX
// Copyright:   
/////////////////////////////////////////////////////////////////////////////

#ifndef __PlotBandStructure_H__
#define __PlotBandStructure_H__

#ifdef __GNUG__
    #pragma interface "PlotBandStructure.h"
#endif

// Include wxWindows' headers

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

#include "PlotBandStructure_wdr.h"

// WDR: class declarations

//----------------------------------------------------------------------------
// PlotBandStructure
//----------------------------------------------------------------------------

class PlotBandStructure: public wxFrame
{
public:
    // constructors and destructors
    PlotBandStructure( wxWindow *parent, wxWindowID id, const wxString &title,
        const wxPoint& pos = wxDefaultPosition,
        const wxSize& size = wxDefaultSize,
        long style = wxDEFAULT_FRAME_STYLE );
    
private:
    // WDR: method declarations for PlotBandStructure
    void CreateMyMenuBar();
    void CreateMyToolBar();
    void PlotBand();
    void PlotDOS();
private:
    // WDR: member variable declarations for PlotBandStructure
    Matrix<double> e;
    vector<double> w;
    double FermiLevel, Emin, Emax;
    wxString FileName;
private:
    // WDR: handler declarations for PlotBandStructure
    void PlotIt( wxCommandEvent &event );
    void FileBrower( wxCommandEvent &event );
    void OnAbout( wxCommandEvent &event );
    void OnQuit( wxCommandEvent &event );
    void OnCloseWindow( wxCloseEvent &event );
    
private:
    DECLARE_EVENT_TABLE()
};

//----------------------------------------------------------------------------
// PlotBandStructureApp
//----------------------------------------------------------------------------

class PlotBandStructureApp: public wxApp
{
public:
    PlotBandStructureApp();
    
    virtual bool OnInit();
    virtual int OnExit();
};

#endif
