//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-

#include "AppBase/ParticleLayoutManager.h"
#include "Utilities/OhmmsInfo.h"

/**@ingroup ohmmsxml
 * @ XML node with tag = ParticleLayout

   usage: 
   <ParticleLayout
    method="grid|N2|metis|optimize"
    scale="double"
    mpi="yes|no"
    omp="yes|no"/>

   Default: <ParticleLayout method="grid" scale="1" mpi="no" omp="no"/>

   Action: intialize/reset the nearest neighbor engine and the method
   The action is valid only after <ParticleSets/> is processed.
 */
namespace OHMMS {

  ParticleLayoutManager::ParticleLayoutManager(OhmmsElementSet& nodelist,
					       const char* aname): 
    OhmmsElementBase(aname), NodeList(nodelist)
  { }

  void ParticleLayoutManager::reset() { }  

  bool ParticleLayoutManager::put(xmlNodePtr cur) {
    //Delegate to Potential Manager
    return NodeList.getNode(Key_potential)->put(cur);
  }
}
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 364 $   $Date: 2005-07-13 13:33:56 -0500 (Wed, 13 Jul 2005) $
 * $Id: ParticleLayoutManager.cpp 364 2005-07-13 18:33:56Z jnkim $ 
 ***************************************************************************/
