//////////////////////////////////////////////////////////////////
//                        COPYRIGHT NOTICE
// (c) Copyright 1998-2002 by Dallas Trinkle and Jeongnim Kim
//   All rights reserved.
//////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-

#ifndef OHMMS_BCCIRREDUCIBLEKPOINT_H
#define OHMMS_BCCIRREDUCIBLEKPOINT_H
#include "CrystalSymmetry/KPointBase.h"

namespace OHMMS {
/**class K-points for BCC lattice.
 *@brief Adaptation of Dallas' Trinkles repusette.C
 */
class BCCKPoint: public KPointBase {

public:

  typedef KPointBase::Lattice_t           Lattice_t;
  typedef KPointBase::SingleParticlePos_t SingleParticlePos_t;

  BCCKPoint(Lattice_t&);
  ~BCCKPoint();

  bool build(int *l= NULL);
  void build_k_plus_q();
  bool foundinIRBZ(const SingleParticlePos_t& dr) const {
    return ((dr[0]+dr[1] >= 0) && (dr[1]+dr[2] <= 1) && 
            (dr[0] <= dr[1]) && (dr[1] <= dr[2]) &&
            (dr[0]+dr[1]+2*dr[2] <= 1));
  }
  //bool foundinIRBZ(const SingleParticlePos_t& dr) const {
  //  SingleParticlePos_t q = LatRef.toUnit(dr);
  //  return ((q[2] >= 0) && (q[0] <= bcc0) && (q[1] <= q[0]) && 
  //          (q[2] <= q[1]) && (q[0]+q[1] <= bcc0) );
  //}

private:
  double bcc0; 
};
}
#endif
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: BCCKPoint.h 151 2004-11-02 23:51:14Z jnkim $
 ***************************************************************************/
