c
      subroutine rlv3 (ai,xb,vr,il)
c            written on september 11th, 1979 - from acmi complex
c     auxiliary subroutine to group1
c     subroutine rlv removes a direct lattice vector from xb leaving the
c     remainder in vr.  if a nonzero lattice vector was removed, il is
c     made nonzero.  vr stands for v-reference.
c     ai(i,j) are the reciprocal lattice vectors, b(i) = ai(i,j),j=1,2,3
c     vr is not given in cartesian coordinates but
c     in the system a1,a2,a3.     k.k., 23.10.1979

      implicit none
      integer il
      double precision ai(3,3),xb(3),vr(3)
      double precision  del(3)
      double precision eps,ts
      integer i,j
      parameter ( eps = 1.0d-4 )
c-----------------------------------------------------------------------
      il = 0
      ts = 0.0
      do 100 i = 1,3
        del(i) = 0.0
        vr(i) = 0.0
        ts = ts + abs(xb(i))
100     continue
      if (ts .le. eps) return
      do 120 i = 1,3
        do 110 j = 1,3
          vr(i) = vr(i) + ai(i,j)*xb(j)
110       continue
      if (vr(i) .gt.  0.9) del(i) = eps
      if (vr(i) .lt. -0.9) del(i) = - eps
c     del is added in to eliminate roundoff errors in the function mod.
      vr(i) = vr(i) + del(i)
      il    = il + int(abs(vr(i)))
      vr(i) = - mod(vr(i),1.d0)
      vr(i) = vr(i) + del(i)
120   continue
      return
      end
