      subroutine trgsym(pgind,s,ntot,iut)
      implicit none
c   sets up the rotation matrices for trigonal(r) groups.  for these
c   groups, the z-axis is chosen as the 3-fold axis, but the
c   crystallographic vectors form a three-fold star around the z-axis,
c   and the primitive cell is a simple rhombohedron.
c   if c is the cosine of the angle between any pair of crystallo-
c   graphic vectors, and if tx=sqrt((1-c)/2), ty=sqrt((1-c)/6),
c   tz=sqrt((1+2c)/3), the crystallographic vectors are
c         a1=a(0,2ty,tz),  a2=a(tx,-ty,tz),  a3=a(-tx,-ty,tz).
c
      integer ntot,iut
      integer pgind,s(3,3,48),sum
      integer i,j,k,kind

      if(pgind.lt.6.or.pgind.gt.10) go to 100
      do 1 k=1,48
      do 1 j=1,3
      do 1 i=1,3
    1 s(i,j,k)=0
      do 2 i=1,3
    2 s(i,i,1)=1
c  point group 3.
      ntot=3
      s(1,3,2)=1
      s(2,1,2)=1
      s(3,2,2)=1
      s(1,2,3)=1
      s(2,3,3)=1
      s(3,1,3)=1
      if(pgind.eq.6) return
      if(pgind.eq.7.or.pgind.eq.10) go to 15
      ntot=6
c   set up c2x.
      s(1,1,4)=-1
      s(3,2,4)=-1
      s(2,3,4)=-1
      if(pgind.eq.8) go to 12
c   set up mx.
      do 11 j=1,3
      do 11 i=1,3
   11 s(i,j,4)=-s(i,j,4)
c  point group 32 =3(x)c2x or 3m = 3(x)mx.
   12 do 14 kind=2,3
      do 14 i=1,3
      do 14 j=1,3
      sum=0
      do 13 k=1,3
   13 sum=sum+s(i,k,4)*s(k,j,kind)
   14 s(i,j,kind+3)=sum
      return
   15 ntot=6
c   point group <3> = 3(x)i
      do 16 kind=1,3
      do 16 j=1,3
      do 16 i=1,3
   16 s(i,j,kind+3)=-s(i,j,kind)
      if(pgind.eq.7) return
c   point group <3>m = <3>(x)mx
      ntot=12
      s(1,1,7)=1
      s(2,3,7)=1
      s(3,2,7)=1
      do 18 kind=2,6
      do 18 j=1,3
      do 18 i=1,3
      sum=0
      do 17 k=1,3
   17 sum=sum+s(i,k,7)*s(k,j,kind)
   18 s(i,j,kind+6)=sum
      return
  100 write(iut,110) pgind
  110 format(' point group ',i3,' is not trigonal')
      ntot = 1
      do 301 i=1,3
301   s(i,i,1) = 1
      return
      end
