//////////////////////////////////////////////////////////////////
// (c) Copyright 2003  by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#include "OhmmsApp/ParticleSetBuild.h"
#include "AppBase/ProjectData.h"
#include "AppBase/ParticleSets.h"
#include "OhmmsApp/RecordPropertyList.h"
#include "Utilities/OhmmsInfo.h"
using namespace std;
namespace OHMMS {

  ParticleSetBuild::ParticleSetBuild(OhmmsElementSet& nodelist, 
				     const char* aname): 
    OhmmsElementBase(aname),NodeList(nodelist)
  {  }

  bool ParticleSetBuild::get(ostream& os) const {
    return true;
  }

  bool ParticleSetBuild::put(istream& is) {
    return true;
  }

  void ParticleSetBuild::reset() {  }

  bool ParticleSetBuild:: put(xmlNodePtr cur){

#if defined(HAVE_LIBXML2)

    RecordPropertyListManager records(NodeList);

    cur = cur->xmlChildrenNode;
    int irecord = NodeList.size();
    map<string,int> nodes;
    nodes["particlesets"]   = Key_particle;
    nodes["particlelayout"] = Key_playout;
    nodes["record"]         = irecord;
    vector<xmlNodePtr> Loops;
    while (cur != NULL) {
      string cname((const char*)(cur->name));
      map<string,int>::iterator it = nodes.find(cname);
      if(it != nodes.end()) {
	int inode = (*it).second;
	if(inode < irecord) {
	  NodeList.getNode(inode)->put(cur);
	} else if(inode == irecord) {
	  records.put(cur);
	}
      }
      cur = cur->next;
    }

    records.reset();
    records.report(1);
#endif
    return true;
  }
}
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 157 $   $Date: 2004-11-03 16:10:50 -0600 (Wed, 03 Nov 2004) $
 * $Id: ParticleSetBuild.cpp 157 2004-11-03 22:10:50Z jnkim $ 
 ***************************************************************************/

