//////////////////////////////////////////////////////////////////
// (c) Copyright 2004  by Jeongnim Kim and Charles Cornwell
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//
// Original c code was developed by C. Cornwell at ARL.
// Modified for OHMMS and other related products.
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef SWCNTBUILDER_H
#define SWCNTBUILDER_H

class SWCNTBuilder {

  double m_bond;

  typedef struct {
    double x,y,z,d; 
  } vec;

public:

  SWCNTBuilder();

  void build(int n1, int n2, int n_uc);

private:

  int p1p2(vec *R1, vec *R2, int *p1, int *p2, int n1, int n2, int *N);
  double dot(vec *a, vec *b);
  int cross(vec *a, vec *b, vec *c);
  double cos_th(vec *a, vec *b);
  double theta(vec *a, vec *b);
  int rot(vec *a, vec *b, double th2, int q);
  int unit(vec *a);
  int LCD(int a, int b);
  double LENGTH(int a, int b, vec *r);
};
#endif  
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: SWCNTBuilder.h 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/
