//////////////////////////////////////////////////////////////////
// (c) Copyright 2004-  by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_SCANUNITCELL_H
#define OHHMS_SCANUNITCELL_H

#include "AppBase/OhmmsElementSet.h"
#include "AppBase/ParticleSets.h"

namespace OHMMS {

  class PotentialCollection;
  class PropagatorBase;

  class ScanUnitCell: public OhmmsElementBase {

  public:
    // constructors and destructors
    ScanUnitCell(OhmmsElementSet& nodelist, const char* aname="scan-unitcell");

    ~ScanUnitCell();

    bool get(std::ostream& os) const;
    bool put(std::istream& is);
    bool put(xmlNodePtr cur);
    void reset();

  private:

    typedef ParticleSets::Particle_t::Tensor_t Tensor_t;
    typedef ParticleSets::Particle_t::Scalar_t Scalar_t;

    OhmmsElementSet& NodeList;

    int NumConfig;    
    int MinSteps;
    Scalar_t LowerScale, UpperScale;    
    Tensor_t FirstLattice, LastLattice, DeltaLattice;

    PropagatorBase* cg_minimizer;
    ParticleSets::Particle_t* myPtcl;
    PotentialCollection* myPot;

    void processXmlNode(xmlNodePtr cur);
    double getMinimumConfig(PotentialCollection* workingpot);
  };
}
#endif
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 254 $   $Date: 2005-01-14 11:40:45 -0600 (Fri, 14 Jan 2005) $
 * $Id: ScanUnitCell.h 254 2005-01-14 17:40:45Z jnkim $ 
 ***************************************************************************/
