#####################################
#subdir OhmmsApp
#####################################
#
@applist = ("OhmmsElementSet",
	    "RandomNumberControl",
	    "ParticleSets", 
	    "ProjectData", 
	    "WorkingPropagator", 
	    "IonicPotential", 
	    "TransformParticle", 
	    "ShapeParticle", 
	    "ParticleLayoutManager", 
	    "MDRun", 
	    "NEBRun", 
	    "RecordPropertyList",
	    "Test",
	    "OhmmsApp" 
	    ); 

if($elph_able) {
    push(@applist,"ElectronPhononCoupling");
}


if($dimer_able) {
    push(@applist,"DimerRun");
}

push(@applist,"main");

&add_ohmms_package("MAINAPPS",
                   "OhmmsApp",
		   @applist
		   );

sub create_config 
{
    #my $mfile = "$dirstr/src/OhmmsApp/config.h";
    my $mfile = "$build_dir/AppConfig.h";
    print "Creating a file $mfile\n";
    open(MFILE,">$mfile") or die "Cannot open $mfile for write.\n";

    select MFILE;

print "//////////////////////////////////////////////////////////////////\n";
print "// (c) Copyright 2003-  by Jeongnim Kim\n";
print "//////////////////////////////////////////////////////////////////\n";
print "//////////////////////////////////////////////////////////////////\n";
print "//   National Center for Supercomputing Applications &            \n";
print "//   Materials Computation Center                                 \n";
print "//   University of Illinois, Urbana-Champaign                     \n";
print "//   Urbana, IL 61801                                             \n";
print "//   e-mail: jnkim\@ncsa.uiuc.edu                                  \n";
print "//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)               \n";
print "//                                                                \n";
print "// Supported by                                                   \n";
print "//   National Center for Supercomputing Applications, UIUC        \n";
print "//   Materials Computation Center, UIUC                           \n";
print "//////////////////////////////////////////////////////////////////\n";
print "// -*- C++ -*-                                                    \n";
print "#ifndef OHMMS_OHMMSAPP_CONFIG_H                                   \n";
print "#define OHMMS_OHMMSAPP_CONFIG_H                                   \n";
print "                                                                  \n";
print "//Comment out macros if a feature is not needed                   \n";
print "//enable/disable Stillinger-Weber potential                       \n";
print "#define ENABLE_SW 1                                               \n";
print "                                                                  \n";
print "//enable/disable Modified Embedded Atom method                    \n";
print "#define ENABLE_MEAM 1                                             \n";
print "                                                                  \n";
print "//enable/disable Embedded Atom method                             \n";
print "#define ENABLE_EAM 1                                              \n";
print "                                                                  \n";
print "//enable/disable Keating potential                                \n";
print "#define ENABLE_KEATING 1                                          \n";
print "                                                                  \n";
print "//enable/disable Lennard-Jones potential                          \n";
print "/* #undef ENABLE_LJ  */                                           \n";

    if($tb_able) {
        print "\n//enable/disable TB potential\n";
        print "#define ENABLE_TB 1\n";
    }

    if($fc_able) {
	print "\n//enable/disable phonon (force-constant) method\n";
	print "#define ENABLE_FORCECONSTANT 1\n";
    }


    if($dimer_able) {
	print "\n//enable/disable Dimer method\n";
	print "#define ENABLE_DIMER 1\n";
    }

    if($tb_able && $elph_able) {
	print "\n//enable/disable Electron-Phonon coupling calculations\n";
	print "#define ENABLE_ELPH 1\n";
    }


    print "\n#endif\n";
    print "/*************************************************************************\n";
    print "* \$RCSfile$   \$Author: jnkim                        \n";
    print "* \$Revision: 151 $   \$Date: 2003/11/18 15:04:08                      \n";
    print "* \$Id: object.pl,v 1.6 2003/11/18 15:04:08 jnkim Exp                   \n"; 
    print "*************************************************************************/\n";
    close(MFILE);
    select STDOUT;
}

&create_config;

1;
