//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_NUMERIC_MATRIX_OPERATORS_H
#define OHMMS_NUMERIC_MATRIX_OPERATORS_H
#include "OhmmsNumeric/Matrix.h"
namespace OHMMS {

  void debug_print(const RealMatrix_t&);

  RealMatrix_t::Type_t 
  Dot(const RealMatrix_t& a, const RealMatrix_t& b);

  void axpy(RealMatrix_t::Type_t x, const RealMatrix_t& a, RealMatrix_t& b);

  void addDiagonal(RealMatrix_t& a, double x);

  void 
  xAAt_plus_yC(RealMatrix_t::Type_t x, const RealMatrix_t& A, 
              RealMatrix_t::Type_t y, RealMatrix_t& C);

  void 
  xAB_plus_yC(RealMatrix_t::Type_t x,
              const RealMatrix_t& A,const RealMatrix_t& B,
	      RealMatrix_t::Type_t y,  RealMatrix_t& C);

  void 
  xABt_plus_yC(RealMatrix_t::Type_t x, 
               const RealMatrix_t& A, const RealMatrix_t& B,
	       RealMatrix_t::Type_t y, RealMatrix_t& C);

  void 
  xABt_xBAt_plus_yC(RealMatrix_t::Type_t x, 
                    const RealMatrix_t& A, const RealMatrix_t& B,
		    RealMatrix_t::Type_t y, RealMatrix_t& C);

  void copy(const RealMatrix_t& A, RealMatrix_t& B);

  RealMatrix_t::Type_t Trace(const RealMatrix_t& a, const RealMatrix_t& b);

  void fill_lower(RealMatrix_t&);

//    // q = 2I - <psi|psi>
//    void TwoIMinusS(const RealMatrix_t& psi, RealMatrix_t& q);//

//    //atb = <bra|ket> \equiv prod(bra,transpose(ket))
//    void AtB(const RealMatrix_t& bra, const RealMatrix_t& ket, 
//  	   RealMatrix_t& atb);

//    // G = prod(Q,HPsi)-prod(H,Psi)
//    void QHPsiMinusHPsi(const RealMatrix_t& Q, const RealMatrix_t& HPsi, 
//  		      const RealMatrix_t& H, const RealMatrix_t& Psi, 
//  		      RealMatrix_t& G);

//    void ABminusCD(const RealMatrix_t& A, const RealMatrix_t& B,
//  		 const RealMatrix_t& C, const RealMatrix_t& D,
//  		 RealMatrix_t& G);



//    //c = alph*a*b  
//    void product(const RealMatrix_t& a, const RealMatrix_t& b, double alpha,
//  	       RealMatrix_t& c);


}

#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: MatrixOperators.h 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/

