//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_PARTICLELAYOUTMANAGER_H__
#define OHMMS_PARTICLELAYOUTMANAGER_H__

#include "OhmmsData/OhmmsElementBase.h"
#include "ParticleSets.h"

namespace OHMMS {

  /** class ParticleLayout
   *  @brief 
   *    Initialize or reset the particle layout and 
   *    the nearest-neighbor engine.
   */
  class ParticleLayoutManager: public OhmmsElementBase {

  public:

    /// constructors and destructors
    ParticleLayoutManager(ParticleSets& P,
			  const char* aname="particlelayout");
    
    bool get(ostream& os) const { return true;}
    bool put(istream& is) {return true;}
    bool put(xmlNodePtr cur);
    void reset();

  private:

    ///set of input particle sets
    ParticleSets& PtclSetRef;
  };
}

#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: ParticleLayoutManager.h 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/
