#ifndef OHMMS_QT_PARTICLESCENE_H
#define OHMMS_QT_PARTICLESCENE_H
#include <QGLViewer/qglviewer.h>
#include "Particle/ParticleSet.h"
#include <vector>
#include <qptrvector.h>


class ParticleScene: public QObject
{

  Q_OBJECT

public:

  typedef float          RealType;
  typedef qglviewer::Vec PointType;
  typedef OHMMS::ParticleSet Particle_t;
  typedef OHMMS::ParticleSet::SingleParticlePos_t SingleParticlePos_t;

  ParticleScene();

public slots:

  void connectParticle(Particle_t* p);
  void draw();
  void drawBox();
  void drawParticles();

private:

  Particle_t* mySys;

  PointType Center;
  RealType Scale, invScale;

  std::vector<SingleParticlePos_t>  UnitLattice;
  std::vector<PointType>  Lattice;
  std::vector<PointType>  R;

  //QPtrVector<GLUquadricObj> showR;
  std::vector<GLUquadricObj*> showR;
  
};
#endif
