#ifndef OHMMS_MAINWINDOW_H_
#define OHMMS_MAINWINDOW_H_
#include <vector>
#include <qmainwindow.h>
#include <qintdict.h>
#include <qptrvector.h>
#include "Particle/ParticleSet.h"
using namespace OHMMS;

class QToolButton;
class QPopupMenu;
class QTabWidget;
class QListView;
class QListViewItem;
class QButtonGroup;
class QTextEdit;

/*!
  \brief A main window for dataspork
*/

class ParticleSetEditor;
class ParticleScene;
class Viewer;
class ParticleSetWindow: public QMainWindow
{
  Q_OBJECT

public:

  ParticleSetWindow();

public slots:

  void slotLoad(const QString& );
  void slotSave(const QString& );

private slots:

  void slotLoad();
  void slotSave();
  void slotSaveAs();

signals:

  void load(const QString&);
  void save(const QString&);

private:

  QMenuBar* initMenuBar();
  QToolBar* initToolBar();
  void initWhatsThis();

private:

  QPopupMenu *_filemenu;
  QPopupMenu *_setmenu;
  QPopupMenu *_plotmenu;
  QButtonGroup *_plotgroup;
  QTextEdit *d_log;

  ParticleSetEditor* editSystem;
  ParticleScene* viewSystem;

  std::vector<Viewer*> viewers;
  OHMMS::ParticleSet theSystem;

};

#endif
