#ifndef OHMMS_SIMPLETREEBUILDER_H
#define OHMMS_SIMPLETREEBUILDER_H

// template<class NP>
// void 
// SimpleTreeBuilder(QListViewItem *parentItem, NP parentNode){}

/*
void SimpleTreeBuilder(QListViewItem *parentItem, xmlNodePtr parentNode) {

  QListViewItem *thisItem = 0;
  xmlNodePtr cur=parentNode->children;
  while(cur != NULL) {
    QString cname((const char*)(cur->name));
    if(cname != "comment") {
      if(parentItem != 0) {
	if(cname == "text") {
	  parentItem->setText(1,(const char*)(cur->content));
	} else 
	  if(cname == "parameter"){
	    thisItem = new QListViewItem(parentItem,thisItem);
	    ///process attributes: type or format
	    xmlAttrPtr att = cur->properties;
	    while(att != NULL) {
	      QString aname((const char*)(att->name));
	      if(aname == "role") {
		thisItem->setText(0,(const char*)(att->children->content));
	      } else if(aname == "condition") {
		thisItem->setText(2,(const char*)(att->children->content));
	      }
	      att = att->next;
	    }
	    thisItem->setText(1,(const char*)(cur->children->content));
	  } else {

	    thisItem = new QListViewItem(parentItem,thisItem);
	    thisItem->setText(0,cname);

	    SimpleTreeBuilder(thisItem,cur);

	    ///process attributes: type or format
	    xmlAttrPtr att = cur->properties;
	    while(att != NULL) {
	      QString aname((const char*)(att->name));
	      if(aname == "name") {
		thisItem->setText(1,(const char*)(att->children->content));
	      } else {
		new QListViewItem(thisItem,aname,(const char*)(att->children->content));
	      }
	      att = att->next;
	    }
	    
	  }
      }
    }
    cur = cur->next;
  }
}
*/
void SimpleTreeBuilder(QListViewItem *parentItem, const QDomElement& parentNode) {

  QListViewItem *thisItem = 0;
  QDomNode node = parentNode.firstChild();
  while ( !node.isNull() ) {
    if(node.isElement() && node.nodeName() != "comment") {
      if(parentItem != 0) {
 	if(node.isText()) {
 	  parentItem->setText(1,node.nodeValue());
	} else {
 	  if(node.nodeName() == "parameter"){
	    thisItem = new QListViewItem(parentItem,thisItem);
	    QDomNamedNodeMap att_map=node.attributes();
	    for(int i=0; i<att_map.count(); i++) {
	      QDomNode att=att_map.item(i);
	      if(att.nodeName() == "role") 
		thisItem->setText(0,att.nodeValue());
	      else if(att.nodeName() == "condition") 
		thisItem->setText(2,att.nodeValue());
	    }
	    if(!node.firstChild().isNull())
	      thisItem->setText(1,node.firstChild().nodeValue());
	  } else {
	    thisItem = new QListViewItem(parentItem,thisItem);
	    thisItem->setText(0,node.nodeName());
	    SimpleTreeBuilder(thisItem,node.toElement());
	    QDomNamedNodeMap att_map=node.attributes();
	    for(int i=0; i<att_map.count(); i++) {
	      QDomAttr att=att_map.item(i).toAttr(); //QDomNode att=att_map.item(i);
	      thisItem->setText(1,att.nodeValue());
	      
	    }
	  }
	}
      }
    }
    node = node.nextSibling();
  }
  if(thisItem) thisItem->setOpen(true);
}
#endif
