#include "OhmmsQt/multiView.h"
#include "OhmmsQt/ParticleScene.h"

using namespace qglviewer;
using namespace std;

Viewer::Viewer(ParticleScene* const s, int type, 
	       QWidget* parent)
  : QGLViewer(parent), scene_(s)
{
  // Previous viewer geometry and window position
  restoreFromFile();
  
  //setDrawAxis();
  //setDrawGrid();
  
  if (type < 3)
    {
      // Move camera according to viewer type (on X, Y or Z axis)
      camera()->setPosition((type==0)? 1.0 : 0.0, (type==1)? 1.0 : 0.0, (type==2)? 1.0 : 0.0);
      camera()->lookAt(sceneCenter());
      
      camera()->setType(Camera::ORTHO);
      camera()->showEntireScene();
      
      // Forbid rotation
      WorldConstraint* constraint = new WorldConstraint();
      constraint->setRotationConstraintType(AxisPlaneConstraint::FORBIDDEN);
      camera()->frame()->setConstraint(constraint);
    } else {
      std::cout << "Help me!!! " << camera()->position() << std::endl;
      // Move camera according to viewer type (on X, Y or Z axis)
      camera()->lookAt(sceneCenter());
      camera()->setPosition(0.0,1.0,1.0);
      std::cout << "Help me!!! " << camera()->position() << std::endl;
      camera()->showEntireScene();
    }
  
}

void Viewer::draw()
{
  setBackgroundColor(0.9,0.9,0.7);
  scene_->draw();
}

