// -*- C++ -*-
#ifndef OHMMS_UNITS_H
#define OHMMS_UNITS_H

/** @file OhmmsUnits.h
 * Add Commonly used conversion factors and constants.
 * The basic units are eV and AA.
 */
namespace OHMMS {

  const int LineBufferSize = 1024;
  const double amu_to_mass_unit = 1.036437626e2;
  const double bohr = 0.529177e0; // in AA
  const double rydberg = 13.6058e0; // in eV
  const double eV_to_Kelvin = 1.16044e4; 
  const double thz_to_eV = 0.2418e-3; 
  const double eV_to_thz = 4.13564929694e3; 
  const double Kelvin_to_eV = 8.617420978e-5;
  const double pressure_to_gpa = 160.219e0;
  const double pressure_to_kbar = 1602.19e0;
  const double zeroKelvin = 1e-9;
  const double DampingFactor = 2.0e0/(1.0e0+0.05/2.0e0);
}

#endif


/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 255 $   $Date: 2005-01-14 11:41:16 -0600 (Fri, 14 Jan 2005) $
 * $Id: OhmmsUnits.h 255 2005-01-14 17:41:16Z jnkim $ 
 ***************************************************************************/

