/***************************************************************************
 * C++ implementation of F90 module of the TBMD program written by
 * Dr. F. Kirchhoff and Prof. F. S. Khan Dept. of Electrical Engineering, 
 * Ohio State University  
 ***************************************************************************/
#ifndef LINE_MINIMIZE_FTNS
#define LINE_MINIMIZE_FTNS

#include <complex>
#include <vector>
using namespace std;

double line_minimization(double x1, double x2, 
                          double f1, double f2, double df1,
                          double& fmin, vector<double>& fit);
double line_minimization(double x1, double x2, double x3,
                          double f1, double f2, double f3,
                          double& fmin, vector<double>& fit);
double line_minimization(double x1, double x2, double x3, double x4,
                          double f1, double f2, double f3, double f4,
                          double& fmin, vector<double>& fit);
double line_minimization(double x1, double x2, double x3,
                          double f1, double f2, double f3, double df1,
                          double& fmin, vector<double>& fit);
double line_minimization(double x1, double x2,
                          double f1, double f2, double df1, double df2,
                          double& fmin, vector<double>& fit, unsigned& info);

extern void laguer(vector<complex<double> >& a, int m,
		   complex<double>& x,double eps,bool polish);
extern void zroots(vector<complex<double> >& a,int m,
		   vector<complex<double> >& roots,bool polish);

extern double getOptima(const vector<double>& e, bool getMinimum);

#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * POOMA_VERSION_ID: $Id: line_min_ftns.h 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/








