//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_EVENTDETECTORFACTORY_H
#define OHMMS_EVENTDETECTORFACTORY_H

#include "Particle/EventDetectorBase.h"

/*! \class EventDetectorFactory
 *  \author Jeongnim Kim
 *  \brief the Builder pattern  for instantiating EventDetectroBase*.
 * 
 *  Used by XYZ2RelaxPropagator, ReplicaPropagator ...
 */

EventDetectorBase* createEventDetector(int argc, char **argv);
EventDetectorBase* createEventDetector(vector<string>& );
#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: EventDetectorFactory.h 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/
