//////////////////////////////////////////////////////////////////
// (c) Copyright 2005- by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
/**@file MetisConnection.cpp
 * @brief Definition of MetisConnection member function.
 */
#include "Particle/MetisConnection.h"
#include <set>
void 
MetisConnection::update(const MetisConnection& conn, bool unique) {
  if(unique) {
    NumData=conn.NumData;
    M.resize(NumData+1);
    J.clear();
    J.reserve(conn.getTotNadj());
    M[0]=0;
    for(int i=0; i<NumData; i++) {
      std::set<int> j(conn.begin(i),conn.end(i));
      J.insert(J.end(),j.begin(),j.end());
      M[i+1]=M[i]+j.size();
    }
  } else {
    *this = conn;
  }
}
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 324 $   $Date: 2005-03-19 15:12:37 -0600 (Sat, 19 Mar 2005) $
 * $Id: MetisConnection.cpp 324 2005-03-19 21:12:37Z jnkim $ 
 ***************************************************************************/
