//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_PARTICLE_METISGRAPHPARTITION_H
#define OHMMS_PARTICLE_METISGRAPHPARTITION_H

#include "Message/OpenMP.h"
extern "C" {
#include <metis.h>
}

template<class IndexListType>
struct MetisGraphPartition {

  MetisGraphPartition(int npart=1,bool reorder=false):
    NumPart(npart), Reorder(reorder) { }
  
  bool Reorder;
  int pid;
  int NumPart;
  IndexListType M;

  //distribution information of the grid on which the metis graph partition is performed.
  //IndexList_t distID;
  IndexListType firstIndex, lastIndex;
  std::vector<IndexListType> gSet;

  void partition(IndexListType& m, 
		 IndexListType& id, 
		 IndexListType& w, 
		 IndexListType& newid) {
    int wgtflag = 2;//weight is used
    int numflag = 0;//c-style
    int metisopt[5]; metisopt[0] = 0;//using default
    int volume;
    int ng = w.size();

    //distID.resize(ng,0);    
    if(NumPart>1) {
      METIS_PartGraphRecursive(&ng, &(m[0]), &(id[0]), &(w[0]),NULL,
			       &wgtflag,&numflag,&(NumPart), metisopt,
			       &volume,&(newid[0]));
    } else {
      WARNMSG("Metis partition is requested with one partition.")
    }

    M.resize(NumPart+1,0);
    gSet.erase(gSet.begin(), gSet.end());
    for(int ipart=0; ipart<NumPart;ipart++) gSet.push_back(IndexListType());
    for(int ig=0; ig<ng; ig++)
      gSet[newid[ig]].push_back(ig);

//     int nacc=0;
//     firstIndex.resize(ng);
//     lastIndex.resize(ng);
//     M[0] = 0;
//     for(int ipart=0; ipart<NumPart; ipart++) {
//       for(int k=0;k<gSet[ipart].size(); k++) {
// 	int ig= gSet[ipart][k];
// 	firstIndex[ig] = nacc;
// 	lastIndex[ig] = nacc+w[ig];
// 	nacc += w[ig];
//       }
//       M[ipart+1] = M[ipart]+nacc;
//      }
  }
};
#endif
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: MetisGraphPartition.h 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/

