//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_NEARESTNEIGHBOR_METISENGINE_H
#define OHMMS_NEARESTNEIGHBOR_METISENGINE_H

#include "Particle/NNEngine.h"

namespace OHMMS {

  /*\class NNMetisMethod
   *\brief Using metis graph partition to set up NN list
   */
  class NNMetisEngine: public NNEngine {

  public:

    enum {ThisMethod = 2};

    NNMetisEngine();
    ~NNMetisEngine();

    // virtual method to evaluate nearest-neighbor lists, indices
    void partition(Particle_t& p);
    void 
      updateR(Particle_t& p, const ParticlePos_t& pos, bool useupdate=true);
    bool initialize(Particle_t&, Scalar_t rmax, bool needvistingforce);
    void evaluate(const Particle_t& p, PtclPairList_t& myppl, int myID);

  protected:

    std::vector<int> CellID;
    bool putExtra(xmlNodePtr cur);
  };
}
#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: NNMetisEngine.h 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/
