//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002,2003- by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_NEARESTNEIGHBOR_NNSIMPLEENGINE_H
#define OHMMS_NEARESTNEIGHBOR_NNSIMPLEENGINE_H

#include "Particle/NNEngine.h"

namespace OHMMS {

  /** Implements N-N search. 
   *
   * When this engine is used for a simulation,
   * one can safely assumes that the number of particles is not too big and
   * spatial distribution of the particles do not make any sense.  Mainly
   * for testings.
   */
  class NNSimpleEngine: public NNEngine {

  public:

    enum {ThisMethod = 1};

    NNSimpleEngine();
    ~NNSimpleEngine();

   bool initialize(Particle_t& p, bool needvisitingforce);
   Index_t updateGridData(const ParticlePos_t& pos, ParticlePos_t& pu, ParticleLayout_t& lattice);

  protected:

    void evalPairsPerThread(const ParticleLayout_t& lattice, 
                            const ParticlePos_t& pos, 
                            const ParticleIndex_t& grID,
                            PtclPairList_t& myppl);
   bool putExtra(xmlNodePtr cur);
    
  };
}
#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 354 $   $Date: 2005-07-07 21:20:49 -0500 (Thu, 07 Jul 2005) $
 * $Id: NNSimpleEngine.h 354 2005-07-08 02:20:49Z jnkim $ 
 ***************************************************************************/
