//////////////////////////////////////////////////////////////////
// (c) Copyright 2005- by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-

#ifndef OHMMS_HDF_RECORDPARTICLE_H
#define OHMMS_HDF_RECORDPARTICLE_H
#include "OhmmsData/RecordProperty.h"
#include "ParticleIO/HDFParticleAttrib.h"
namespace OHMMS {

  struct HDFRecordParticle:public RecordProperty {

    typedef ParticleSet Particle_t;

    Particle_t& ref_;
    string FileName;
    string RootName;
    hid_t ConnectedFile;
    hid_t RootID;

    HDFRecordParticle(Particle_t& a):ref_(a) { }    
    void reset(const char* fileroot);
    void report(int iter);
    void finalize();
    bool put(xmlNodePtr cur);

    vector<string> RecordNames;
    vector<HDFAttribIOBase*> Records;
  };
}
#endif
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 299 $   $Date: 2005-02-16 09:37:33 -0600 (Wed, 16 Feb 2005) $
 * $Id: HDFRecordParticle.h 299 2005-02-16 15:37:33Z jnkim $ 
 ***************************************************************************/
