//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_TBMDPARTICLEPARSER_H
#define OHMMS_TBMDPARTICLEPARSER_H

#include "Particle/ParticleSet.h"

namespace OHMMS {


  class TBMDParticleParser: public ParticleTags {

    typedef ParticleSet                       Particle_t;
    typedef Particle_t::SingleParticleIndex_t SingleParticleIndex_t;
    typedef Particle_t::ParticleLayout_t      ParticleLayout_t;
    typedef Particle_t::ParticlePos_t         ParticlePos_t;
    typedef Particle_t::ParticleIndex_t       ParticleIndex_t;
    typedef Particle_t::ParticleScalar_t      ParticleScalar_t;

    Particle_t& ref_;

  public:

    TBMDParticleParser(Particle_t& aptcl):ref_(aptcl){ }

    ///reading from a file
    bool put(const char*);
 
    void read_lattice(std::istream& fpos, 
		      ParticleLayout_t& lat, 
		      SingleParticleIndex_t& uc_grid);
  };
}

#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: TBMDParticleParser.h 151 2004-11-02 23:51:14Z jnkim $
 ***************************************************************************/
