//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_PARTICLE_INPUTOUTPUT_UTILITY_H
#define OHMMS_PARTICLE_INPUTOUTPUT_UTILITY_H

#include "OhmmsData/OhmmsElementBase.h"
#include "Particle/OhmmsParticle.h"

namespace OHMMS {

  class LatticeParser {
    ParticleLayout_t& ref_;
    public:
    LatticeParser(ParticleLayout_t& lat): ref_(lat){ }
    bool put(xmlNodePtr cur);
  };


  class LatticeXMLWriter {

    ParticleLayout_t& ref_;
    public:

    LatticeXMLWriter(ParticleLayout_t& lat): ref_(lat){ }
    bool get(ostream& ) const;
  };

  class ParticleParser {

    Particle_t& ref_;
  public:

    ParticleParser(Particle_t& aptcl):ref_(aptcl){ }
    ///reading from a file
    ///bool put(const char*);
    bool put(xmlNodePtr cur);
  };



}
#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: ParticleIOUtility.h 151 2004-11-02 23:51:14Z jnkim $
 ***************************************************************************/
