//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_PARTICLE_OUTPUT_FACTORY_H
#define OHMMS_PARTICLE_OUTPUT_FACTORY_H

/////////////////////////////////////////////
// \author Jeongnim Kim
// \class ParticleSaveFactory
// \class ParticleRecordFactory
//
// \brief Substituting ParticleIOFactory
/////////////////////////////////////////////

#include "Ohmms.h"
#include "Particle/OhmmsParticle.h"
using namespace OHMMS;
#include "ParticleIO/ParticleIOBase.h"

class ParticleOutputFactory {

public:

  typedef ParticleIOBase<Scalar_t, OHMMS_DIM> ParticleIO_t;

  // setting options which apply to all the instance
  static void set(int argc, char **argv);
  static void set(vector<string>&);
  static int add(Particle_t&, const char*);
  static bool update(int id, int iter);
  static bool finalize(int id);
  static bool remove();

private:

  ParticleOutputFactory() { }
  ~ParticleOutputFactory() { }

  static int rec_stride;
  static int save_stride;
  static vector<string> options;
  static vector<ParticleIO_t*> save_engine;
  static vector<ParticleIO_t*> rec_engine;
};
#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: ParticleOutputFactory.h 151 2004-11-02 23:51:14Z jnkim $
 ***************************************************************************/
