//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_PARTICLE_INPUTOUTPUT_TBMD_UTILITY_H
#define OHMMS_PARTICLE_INPUTOUTPUT_TBMD_UTILITY_H

#include "OhmmsData/OhmmsElementBase.h"
#include "OhmmsData/RecordProperty.h"
#include "Particle/OhmmsParticle.h"

namespace OHMMS {

  class TBMDSaveParticle: public RecordProperty {

    Particle_t& ref_;
    string FileRoot;

  public:

    typedef Particle_t::ParticlePos_t    ParticlePos_t;
    typedef Particle_t::ParticleIndex_t  ParticleIndex_t;
    typedef Particle_t::ParticleScalar_t ParticleScalar_t;

    TBMDSaveParticle(Particle_t& pin): ref_(pin){ }

    ~TBMDSaveParticle();

    void reset(const char* fileroot);

    void report(int iter);

    bool put(xmlNodePtr cur);

  private:

  };
}

#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: TBMDParticleIO.h 151 2004-11-02 23:51:14Z jnkim $
 ***************************************************************************/
