//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#include "Message/OpenMP.h"
#include "Potentials/AShortRangePotential.h"

namespace OHMMS {

  AShortRangePotential::AShortRangePotential(){ 
    //Set it false, if the potential only has pair-wise interactions
    CollectVisitingForces = true;
  }

  AShortRangePotential::~AShortRangePotential() {

  }

  void AShortRangePotential::initialize() {

  }
  
  bool AShortRangePotential::get(ostream& os) const { 
    return true;
  }

  bool AShortRangePotential::put(istream&) {
    return true;
  }

  void AShortRangePotential::reset() {
  }

  bool AShortRangePotential::put(xmlNodePtr cur){
    return true;
  }

  AShortRangePotential::Scalar_t 
  AShortRangePotential::evalEnergyNN(const PtclPairList_t& nnlist, 
				     int first, int last) {

    Scalar_t  esum = 0.0e0;
    int nnloc=0;
    for(int iat=first, iL = 0; iat<last; iat++, iL++) {
      int num_nn = nnlist.nadj(iL);
      for(int nni = 0; nni< num_nn; nni++, nnloc++) {
      }// for jL < nn
    }
    return esum;
  }

  AShortRangePotential::Scalar_t 
  AShortRangePotential::evalForceNN(PtclPairList_t& nnlist, 
			   ParticlePos_t& f0, 
			   ParticleScalar_t& q, 
			   unsigned stressmode) {

    int myid=nnlist.myID;
    int first=nnlist.First;
    int last=nnlist.Last;
    int nfv=nnlist.Visitors;
    bool multiplethread = nnlist.MultiSet;

    //For two-body potential, fvind,fv and o are not used
    PtclPairList_t::IndexList_t& fvind = nnlist.IDv;
    PtclPairList_t::VectorList_t& fv = nnlist.Fv;
    const ParticleIndex_t* o=NULL;
    if(multiplethread) o = myPtcl->getIndexAttrib(ParticleTags::openmp_tag);


    Scalar_t  esumloc = 0.0;
    Tensor_t  stressloc;
    int nnloc = 0;
    for(int iat=first, iL=0; iat<last; iL++,iat++) {

      int num_nn = nnlist.nadj(iL);
      for(int nni = 0; nni< num_nn; nni++, nnloc++) {
      } // for jL < nn

      if(multiplethread) {
	//separate on-thread from off-thread forces
      } else {

      }
      q[iat] = elocal;
      esumloc += elocal;
    }

    //Assignment to PtclPairList
    nnlist.Visitors = nfv;
    nnlist.Stress = stressloc;
    return esumloc;
  }

}

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: AShortRangePotential.cpp 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/
