//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
///////////////////////////////////////////////////////////////////////
// * This class implements the orthogonal tight-binding model
// * of Harrison scale, i.e., (r0/r)^2 
/////////////////////////////////////////////////////////////////////
#include "Potentials/CompositePotential.h"

CompositePotential::CompositePotential(){

}

CompositePotential::CompositePotential(ThisParticle_t* ptclset):
PotentialBase(ptclset){

}

CompositePotential::CompositePotential(int argc, char **argv){

} 

CompositePotential::~CompositePotential(){

}

void 
CompositePotential::initialize(){

  for(int i=0; i<PotList.size(); i++) PotList[i]->initialize();
}

Scalar_t CompositePotential::evalEnergy(){
  getPairList();
  Scalar_t esum=0;
  for(int i=0; i<PotList.size(); i++) {
    PotList[i]->Counter = Counter; 
    esum += PotList[i]->evalEnergy();
  }
  return esum;
}

Scalar_t 
CompositePotential::evalForce(ParticlePos_t& f, ParticleScalar_t& e, 
                              Tensor_t& stress, unsigned stressmode){
  getPairList();
  Scalar_t esum=0;
  for(int i=0; i<PotList.size(); i++) {
    PotList[i]->Counter = Counter; 
    esum += PotList[i]->evalForce(f,e,stress,stressmode);
  }
  return esum;
}

bool 
CompositePotential::evalDynamicMatrix(DynMatrix_t& dmat){
//    getPairList();
//    for(int i=0; i<PotList.size(); i++) {
//      PotList[i]->Counter = Counter; 
//       PotList[i]->evalDynamicMatrix(dmat);
//    }
  return false;
}

Scalar_t CompositePotential::e(const ParticlePos_t& rin, int iat){  
  Scalar_t esum=0;
  for(int i=0; i<PotList.size(); i++) {
    esum += PotList[i]->e(rin,iat);
  }
  return esum;
}

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: CompositePotential.cpp 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/
