//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-

#include "Message/OpenMP.h"
#include "Potentials/PotentialBase.h"
using namespace OHMMS;

//default constructor
PotentialBase::PotentialBase(): 
  CollectVisitingForces(false),Rmax(-1),myPtcl(0), 
  nnListEngine(0), myRecorder(0),
  PotXmlNode(NULL), LayoutXmlNode(NULL)
{

}

PotentialBase::~PotentialBase()
{
  DEBUGMSG("Calling PotentialBase::~PotentialBase()");
  //Potential memory leak: but Record is handled by RecordPropertyListManager
  //if(myRecorder) delete myRecorder;
}


/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 383 $   $Date: 2005-09-05 15:30:56 -0500 (Mon, 05 Sep 2005) $
 * $Id: PotentialBase.cpp 383 2005-09-05 20:30:56Z jnkim $ 
 ***************************************************************************/

