//////////////////////////////////////////////////////////////////
//                        COPYRIGHT NOTICE
//   (c) Copyright 1998-2002 David A. Richie and Jeongnim Kim.
//   All rights reserved.
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   David A. Richie
//   Department of Physics, Ohio State University
//   174 W 18th Avenue
//   Columbus, OH 43210
//
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//
// \class RecordPotential
//
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_RECORDPOTENTIAL_H__
#define OHMMS_RECORDPOTENTIAL_H__

#include "OhmmsData/RecordProperty.h"
#include "Potentials/PotentialBase.h"

namespace OHMMS {

  /*!\class RecordPotential
   * \brief Record Engine a PotentialBase
   */
  class RecordPotential: public RecordProperty {

    PotentialBase& ref_;
    RecordProperty *_recorder;

  public:

    RecordPotential(PotentialBase& pot);

    ~RecordPotential();

    void reset(const char* fileroot);

    void report(int iter);

    void finalize();

    bool put(xmlNodePtr cur);

  };

  class SavePotential: public RecordProperty {

    PotentialBase& ref_;

  public:


    SavePotential(PotentialBase& pot): ref_(pot) { }

    ~SavePotential();

    void reset(const char* fileroot);

    void report(int iter);

    void finalize() { }

    bool put(xmlNodePtr cur);

  };

}
#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: RecordPotential.h 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/
