#ifndef POTENTIALTEMPLATE_H
#define POTENTIALTEMPLATE_H

#include "Potentials/PotentialBase.h"

class aPotential:public PotentialBase {

public:

  aPotential() { }
  aPotential(int argc, char **argv); 

  ~aPotential() { }

  void initialize() = 0;
  Scalar_t evalEnergy();
  Scalar_t evalForce(ParticlePos_t& f, ParticleScalar_t&, Tensor_t&,
                     unsigned stressmode = 0);
  Scalar_t evalDynamicMatrix();

  Scalar_t e(const ParticlePos_t&, int i);

  void print(ostream& os, int outputlevel) const; 

};

#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: APotential.h 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/

