//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_LJPOTENTIAL_H
#define OHMMS_LJPOTENTIAL_H

#include <string>
#include <vector>
using namespace std;
#include "Potentials/PotentialBase.h"

template<class ScaleFunc>
class TwoBodyPotential:public PotentialBase {

public:

  TwoBodyPotential(): Phi(NULL){ }
  TwoBodyPotential(ThisParticle_t* ptcl):PotentialBase(ptcl), Phi(NULL){ }
  TwoBodyPotential(int argc, char **argv); 

  ~TwoBodyPotential() { }
  void initialize();

  Scalar_t evalEnergy();
  Scalar_t evalForce(ParticlePos_t& f, ParticleScalar_t& e, Tensor_t&, 
                     unsigned stressmode = 0);
  bool evalDynamicMatrix(DynMatrix_t&);

  Scalar_t e(const ParticlePos_t&, int i, int myid = 0);
  Scalar_t e1(const ParticlePos_t&, int i, Scalar_t h, Scalar_t k, 
	      Scalar_t l, Scalar_t c, int myid = 0);
  Scalar_t e1a(const ParticlePos_t&, int i, Scalar_t h, Scalar_t k, 
	       Scalar_t l, Scalar_t c, int myid = 0);
  Scalar_t e1w(const ParticlePos_t&, int i, Scalar_t h, Scalar_t k, 
	       Scalar_t l, Scalar_t c, Scalar_t w, int myid=0);
  Scalar_t e2(const ParticlePos_t&, int i, Scalar_t h, Scalar_t k, 
	      Scalar_t l, Scalar_t c, int myid=0);

protected:
  vector<string> options;
  ScaleFunc* Phi;
};

#include "Potentials/TwoBodyPotential.cpp"

#endif


/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: TwoBodyPotential.h 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/
