//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-

/** @file APropagator.h
 * @brief A template class for any derived class from PropagatorBase
 */
#ifndef OHMMS_TEMPLATEPROPAGATOR_H
#define OHMMS_TEMPLATEPROPAGATOR_H

#include "Propagators/PropagatorBase.h"
#include "OhmmsData/OhmmsElementBase.h"

namespace OHMMS {

  /** A generic Propagator.
   */
  class APropagator: public PropagatorBase 
  { 

  public:

    APropagator();
    ~APropagator() { }
 
    // implementing virutal functions
    void initialize(Particle_t* ptclin, PotentialBase* potin, bool makecopy = false);
    void setTemperature(bool rescale, Scalar_t tref); 
    bool propagate(PotentialBase*);
    void applyBConds(bool wrapping);
  };
}
#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 228 $   $Date: 2005-01-03 12:22:16 -0600 (Mon, 03 Jan 2005) $
 * $Id: APropagator.h 228 2005-01-03 18:22:16Z jnkim $ 
 ***************************************************************************/
