//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-

#ifndef OHMMS_RECORDPROPAGATOR_H__
#define OHMMS_RECORDPROPAGATOR_H__

#include "OhmmsData/RecordProperty.h"

namespace OHMMS {

  class PropagatorBase;

  class RecordPropagator: public RecordProperty {

    PropagatorBase& ref_;

  public:

    RecordPropagator(PropagatorBase& pin):ref_(pin) {}
    ~RecordPropagator() {}
    void reset(const char* fileroot);
    void report(int iter);

    void finalize() { }
    bool put(xmlNodePtr cur);

  };

  class SavePropagator: public RecordProperty {

    PropagatorBase& ref_;

  public:

    SavePropagator(PropagatorBase& pin):ref_(pin) {}
    ~SavePropagator() {}
    void reset(const char* fileroot);
    void report(int iter);
    void finalize() { }
    bool put(xmlNodePtr cur);
  };
}
#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 298 $   $Date: 2005-02-15 16:05:07 -0600 (Tue, 15 Feb 2005) $
 * $Id: RecordPropagator.h 298 2005-02-15 22:05:07Z jnkim $ 
 ***************************************************************************/
