//////////////////////////////////////////////////////////////////
// (c) Copyright 2004- by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_QUANTUMBASE_ELECTRONSTRUCTUREIO_H
#define OHMMS_QUANTUMBASE_ELECTRONSTRUCTUREIO_H

#include "OhmmsData/RecordProperty.h"

namespace OHMMS {

  class ElectronStructure;

  /**class to record the electronic structure
   */
  struct ESOutput: public RecordProperty {

    bool FirstTime;
    int OutputFormat;

    ElectronStructure& ref_;
    
    ESOutput(ElectronStructure& es);

    void reset(const char* fileroot);

    void report(int iter);

    void finalize();

    bool put(xmlNodePtr cur);
  };
}
#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * POOMA_VERSION_ID: $Id: ElectronStructureIO.h 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/
