//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////

#ifndef OHMMS_MATRIX_SPARSEMATRIX_PRODUCT_H
#define OHMMS_MATRIX_SPARSEMATRIX_PRODUCT_H

namespace OHMMS {

  struct Dense2SparseMatrix {

    typedef RealMatrix_t::Type_t real_type;
  static void product(real_type x, 
               const RealMatrix_t& bra, const RealMatrix_t& ket, 
	       SparseMatrix_t& rho);

  static void product(const RealMatrix_t& bra, const RealMatrix_t& ket, 
	       SparseMatrix_t& rho);

  static void product(const RealMatrix_t& bra, const RealMatrix_t& ket, 
	       const vector<real_type>& w, SparseMatrix_t& rho);

  static void product(const RealMatrix_t& bra, const RealMatrix_t& ket, 
	       const vector<real_type>& w, 
	       SparseMatrix_t& rho_r, SparseMatrix_t& rho_i);

  static void product(const ComplexMatrix_t& bra, const ComplexMatrix_t& ket, 
	       const vector<real_type>& w, SparseMatrix_t& rho);

  static void product(const ComplexMatrix_t& bra, const ComplexMatrix_t& ket, 
	       const vector<real_type>& w, 
	       SparseMatrix_t& rho_r, SparseMatrix_t& rho_i);

  static void product(const RealMatrix_t& bra, PackedSymMatrix_t& den);

  static void product(const SparseMatrix_t& h, const RealMatrix_t& psi, 
	       RealMatrix_t& hpsi);
  };
}

#endif
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: Matrix2SparseMatrixProduct.h 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/
