//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////

#ifndef OHMMS_SPARSEMATRIX_MATRIX_COPY_H
#define OHMMS_SPARSEMATRIX_MATRIX_COPY_H
#include "OhmmsNumeric/Matrix.h"
#include "SparseMatrix/SparseMatrix.h"
namespace OHMMS {

  struct Sparse2DenseMatrix {

    typedef RealMatrix_t::Type_t real_type;
    typedef complex<real_type>   complex_type; 

    static void copy(const SparseMatrix_t& h, PackedSymMatrix_t&  mout);

    static void copy(const SparseMatrix_t& h, RealMatrix_t&    mout, bool up=true);
    static void copy(const SparseMatrix_t& h, PackedHerMatrix_t& mout);
    static void copy(const SparseMatrix_t& h, const SparseMatrix_t& s,
	             real_type mu, RealMatrix_t& mout);

    static void copy(const SparseMatrix_t& h, 
                     ComplexMatrix_t&  mout, bool up=true);

    static void copy(const SparseMatrix_t& h, const complex<real_type>*, 
                     PackedSymMatrix_t&);

    static void copy(const SparseMatrix_t& h, 
                     const complex_type*, 
                     RealMatrix_t&, bool up=true);

    static void copy(const SparseMatrix_t& h, 
                     const complex_type*, 
                     PackedHerMatrix_t& mout);

    static void copy(const SparseMatrix_t& h, 
                     const complex_type*, 
                     ComplexMatrix_t&, bool up=true);

    static bool matrix_equal(const SparseMatrix_t& h, 
                             RealMatrix_t& , bool up=true);
   };
}

#endif
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: SparseMatrix2MatrixCopy.h 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/
