//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_SPARSEMATRIXOPERATORS_H
#define OHMMS_SPARSEMATRIXOPERATORS_H
#include "SparseMatrix/SparseMatrix.h"

namespace OHMMS {

void product(const ComplexMatrix_t& bra, 
             const ComplexMatrix_t& ket, 
 	    const vector<double>& w,
	SparseMatrix_t& mat_r, 
        SparseMatrix_t& mat_i);

void product(const RealMatrix_t& bra, const RealMatrix_t& ket,
  	     const vector<double>& w, SparseMatrix_t& mat);

void product(const double* a, const double*, SparseMatrix_t& mat);
}

#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: SparseMatrixOps.h 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/

