//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_GLOBALMDPARAMETERS_H
#define OHMMS_GLOBALMDPARAMETERS_H

#include <vector>
#include <string>
using namespace std;

class MDParameters;

/*! \class GlobalMDParameters
 *  \brief Responsible for instatiating singleton MDParameters
 *  (Singleton Pattern). For a simulation, OHMMS assumes that
 *  only one set of controlling parameters exists. 
 *  
 *  Any object can request a pointer to the MDParemters 
 *  by calling GlobalMDParameters::getMDParameters().
 */

class GlobalMDParameters {
public:

  static void init(int argc, char** argv);
  static MDParameters* getMDParameters();
  static MDParameters* getMDParameters(int argc, char** argv);
  static MDParameters* getMDParameters(vector<string>&);

protected:

  GlobalMDParameters() { }
  ~GlobalMDParameters();

private:

  static MDParameters*  mdparam;

};

#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: GlobalMDParameters.h 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/
