##////////////////////////////////////////////////////////////////
## (c) Copyright 2003-  by Jeongnim Kim
##////////////////////////////////////////////////////////////////
##////////////////////////////////////////////////////////////////
##   National Center for Supercomputing Applications &
##   Materials Computation Center
##   University of Illinois, Urbana-Champaign
##   Urbana, IL 61801
##   e-mail: jnkim@ncsa.uiuc.edu
##   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
##
## Supported by
##   National Center for Supercomputing Applications, UIUC
##   Materials Computation Center, UIUC
##////////////////////////////////////////////////////////////////
#included by configure.pl
# #!/usr/bin/env perl
#%ohmms_package; 
#@ohmms_subdirs;

sub add_ohmms_package {
    my ($o, $b_dir, @b_objs) = @_;
    push(@ohmms_objects,$o);
    $ohmms_package{$o} .= "$b_dir ";
    foreach my $a (@b_objs) {
	$ohmms_package{$o} .= "$a ";
    }
    1;
}

sub add_ohmms_f77_package {
    my ($o, $b_dir, @b_objs) = @_;
    push(@ohmms_f77_objects,$o);
    $ohmms_f77_package{$o} .= "$b_dir ";
    foreach my $a (@b_objs) {
	$ohmms_f77_package{$o} .= "$a ";
    }
    1;
}

require "$dirstr/src/Utilities/object.pl";
require "$dirstr/src/Message/object.pl";
require "$dirstr/src/Particle/object.pl";
require "$dirstr/src/ParticleIO/object.pl";
require "$dirstr/src/Propagators/object.pl";
require "$dirstr/src/Optimize/object.pl";
require "$dirstr/src/Potentials/object.pl";

if($tb_able || $fc_able) {
    require "$dirstr/src/CrystalSymmetry/object.pl";
    require "$dirstr/src/FortranLib/object.pl";
}

if($tb_able) {
    require "$dirstr/src/SparseMatrix/object.pl";
    require "$dirstr/src/OhmmsNumeric/object.pl";
    require "$dirstr/src/QuantumBase/object.pl";
    require "$dirstr/src/SlaterKosterTB/object.pl";
}

require "$dirstr/src/Platforms/object.pl";
require "$dirstr/src/OhmmsApp/object.pl";

1;

#foreach $a (@ohmms_subdirs)
#{
#  print "$a";
#  print "_o = ";
#  my @olist = split(/ /,$ohmms_package{$a});
#  foreach  $b (@olist) {
#    print "$b.o ";
#  }
#    print  "\n\n";
#}
